/*
Filename    : BTProgressDlg.cpp
Part of     : Phone Navigator
Description : Implementation of bluetooth device search progress dialog
Version     : 1.1

This example is only to be used with PC Suite Connectivity API version 1.1.
Compability ("as is") with future versions is not quaranteed.

Copyright (c) 2005 Nokia Corporation.
 
This material, including but not limited to documentation and any related 
computer programs, is protected by intellectual property rights of Nokia 
Corporation and/or its licensors.
All rights are reserved. Reproducing, modifying, translating, or 
distributing any or all of this material requires the prior written consent 
of Nokia Corporation. Nokia Corporation retains the right to make changes 
to this material at any time without notice. A copyright license is hereby 
granted to download and print a copy of this material for personal use only.
No other license to any other intellectual property rights is granted. The 
material is provided "as is" without warranty of any kind, either express or 
implied, including without limitation, any warranty of non-infringement, 
merchantability and fitness for a particular purpose. In no event shall 
Nokia Corporation be liable for any direct, indirect, special, incidental, 
or consequential loss or damages, including but not limited to, lost profits 
or revenue,loss of use, cost of substitute program, or loss of data or 
equipment arising out of the use or inability to use the material, even if 
Nokia Corporation has been advised of the likelihood of such damages occurring.
*/ 


#include "stdafx.h"
#include "PhoneNavigator.h"
#include "BTProgressDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBTProgressDlg dialog

extern BOOL g_bSearchCancelled;

CBTProgressDlg::CBTProgressDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBTProgressDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBTProgressDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CBTProgressDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBTProgressDlg)
	DDX_Control(pDX, IDC_PROGRESS_SEARCH, m_SearchProgress);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBTProgressDlg, CDialog)
	//{{AFX_MSG_MAP(CBTProgressDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBTProgressDlg message handlers

//===================================================================
// SetProgress
//
// Sets the progress bar position
//===================================================================
void CBTProgressDlg::SetProgress(int iPos)
{
    m_SearchProgress.SetPos( iPos);
}

//===================================================================
// OnInitDialog
//
// Dialog initialization
//===================================================================
BOOL CBTProgressDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
    m_SearchProgress.SetRange( 0, 100);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

//===================================================================
// OnCancel
//
// Cancel button message handler. If Cancel is pressed, sets global
// g_bSearchCancelled flag to TRUE. BT device searching callback
// function BTPairingNotifyCallback() cancels the actual search,
// after g_bSearchCancelled has been set to TRUE.
//===================================================================
void CBTProgressDlg::OnCancel() 
{
	g_bSearchCancelled = TRUE;
	CDialog::OnCancel();
}
