// CmdDlg.cpp : implementation file
//


#include "stdafx.h"
#include "PhoneNavigator.h"
#include "PhoneNavigatorDlg.h"
#include "RenameDlg.h"
#include "CreateDlg.h"
#include "FileOperationListener.h"
#include "BTPairingDlg.h"

#include "CmdDlg.h"

#include "e32keys.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCmdDlg dialog


CCmdDlg::CCmdDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCmdDlg::IDD, pParent)/*, m_lbPhones( m_pLabel )*/
{
	//{{AFX_DATA_INIT(CCmdDlg)
	m_cmd = _T("simulate 180");
	m_cmd = _T("ftp_connect 10000000");
	//}}AFX_DATA_INIT

	m_hFS = NULL;
	m_dwMedia = CONAPI_MEDIA_ALL;
	m_dwDeviceID = 0;

	m_iCmdState = CMD_STATE_NULL;

	m_bThreadStarted = FALSE;

	m_iKeyEventState = CONA_OK;
	m_iSessionState  = CONA_OK;


	m_ScreenPictureRect = CRect(0,0, 176, 208);


}


CCmdDlg::~CCmdDlg()
{

}


void CCmdDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCmdDlg)
	DDX_Control(pDX, IDC_LOGLIST, m_LogList);
	DDX_Text(pDX, IDC_EDIT1, m_cmd);
	DDX_Control(pDX, IDC_STATIC_PHONE_CMD, m_staticPhone);	
	DDX_Control(pDX, IDC_PHONELIST, m_lbPhones);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCmdDlg, CDialog)
	//{{AFX_MSG_MAP(CCmdDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON3, OnMenu)
	ON_BN_CLICKED(IDC_BUTTON4, OnBack)
	ON_BN_CLICKED(IDC_BUTTON5, OnUp)
	ON_BN_CLICKED(IDC_BUTTON6, OnDown)
	ON_BN_CLICKED(IDC_BUTTON2, OnEnter)
	ON_BN_CLICKED(IDC_BUTTON9, OnLeft)
	ON_BN_CLICKED(IDC_BUTTON8, OnRight)
	ON_BN_CLICKED(IDC_BTNAPP, OnApp)
	ON_BN_CLICKED(IDC_BTN_NUM1, OnBtn1)
	ON_BN_CLICKED(IDC_BTN_NUM2, OnBtn2)
	ON_BN_CLICKED(IDC_BTN_NUM3, OnBtn3)
	ON_BN_CLICKED(IDC_BTN_NUM4, OnBtn4)
	ON_BN_CLICKED(IDC_BTN_NUM5, OnBtn5)
	ON_BN_CLICKED(IDC_BTN_NUM6, OnBtn6)
	ON_BN_CLICKED(IDC_BTN_NUM7, OnBtn7)
	ON_BN_CLICKED(IDC_BTN_NUM8, OnBtn8)
	ON_BN_CLICKED(IDC_BTN_NUM9, OnBtn9)
	ON_BN_CLICKED(IDC_BTN_NUM0, OnBtn0)
	ON_BN_CLICKED(IDC_BTN_ELEFT, OnBtnELeft)
	ON_BN_CLICKED(IDC_BTN_ERIGHT, OnBtnERight)
	ON_BN_CLICKED(IDC_BTN_C, OnBtnC)
	ON_BN_CLICKED(IDC_BTN_PEN, OnBtnPen)
	ON_BN_CLICKED(IDC_BTN_RED, OnBtnRed)
	ON_BN_CLICKED(IDC_BTN_GREEN, OnBtnGreen)
	ON_BN_CLICKED( IDC_BTN_START_THREAD, OnStartThread )
	ON_WM_DESTROY()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCmdDlg message handlers

void CCmdDlg::OnOK() 
{
	// TODO: Add extra validation here
	CDialog::OnOK();
}



void CCmdDlg::OnButton1() 
{

	UpdateData();
	m_cmd = m_cmd;
	SendCmd();
}

#define		ALIAS_KEY_SIMULATE	1



void CCmdDlg::SendCmd(int prefix) 
{
	
	CString pszFileName = _T("c:\\cmd.txt");
	CFile cmdFile;
	CFileException fileException;
	
	if ( !cmdFile.Open( pszFileName, CFile::modeWrite |
		CFile::shareExclusive | CFile::modeCreate , &fileException ) )
	{
		AfxMessageBox(_T("Error create file!"));
		return;
	}
	
	if( 1 == prefix )
	{
		m_cmd = _T("simulate ") + m_cmd;
	}
	
	int len = m_cmd.GetLength();
	cmdFile.Write( m_cmd.GetBuffer(1), len * sizeof(TCHAR));
	//cmdFile.Flush();
	cmdFile.Close();


	//    
	if( !m_bThreadStarted )
	{
		SendToPhone();
	}
	else
	{
		//   
		m_iCmdState = CMD_STATE_SENDDATA;
	}
}



const CString g_strPhoneRoot = L"\\\\"; // '\\' means phone root


//
//
//
BOOL CCmdDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	
    // Initializing phone file list:
    m_lbPhones.Init(&m_staticPhone);

    m_lbPhones.ListAllPhones();

	if( m_lbPhones.GetCount())
	{
		CONAPI_DEVICE *pDevice = (CONAPI_DEVICE*)m_lbPhones.GetItemDataPtr(0);
		if(pDevice)
		{ // copying serial number to strRetVal
			m_strCurrentSN = CString(pDevice->pstrSerialNumber);
		}
		
		if(!m_strCurrentSN.IsEmpty())
		{
			m_lbPhones.ResetContent(); // removing phones and cleaning memory
			m_wState = PHONELIST_STATE_PHONECONTENT;
			m_lbPhones.ShowPhoneFolder(g_strPhoneRoot, m_strCurrentSN);
		}


		DWORD dwResult = CONAOpenFS(m_strCurrentSN, &m_dwMedia, &m_hFS, &m_dwDeviceID);
		if(dwResult == CONA_OK)
		{
			//SetTimer( 2, 1000, NULL );
			
			
		}
        else
        {
            ErrorMessageDlg(L"CCmdDlg::OnInitDialog(): CONAOpenFS failed!", dwResult);
        }


	}
	else
	{
		AfxMessageBox( _T("Phone is not connecting !") );
		return TRUE;
	}


	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCmdDlg::OnMenu() 
{
	m_cmd.Format(_T("%d"), EStdKeyDevice0 );
	SendCmd(ALIAS_KEY_SIMULATE);
}

void CCmdDlg::OnBack() 
{
	m_cmd.Format(_T("%d"), EStdKeyDevice1 );
	SendCmd(ALIAS_KEY_SIMULATE);
}

void CCmdDlg::OnUp() 
{
	m_cmd.Format(_T("%d"), EStdKeyUpArrow );
	SendCmd(ALIAS_KEY_SIMULATE);
}

void CCmdDlg::OnDown() 
{
	m_cmd.Format(_T("%d"), EStdKeyDownArrow );
	SendCmd(ALIAS_KEY_SIMULATE);
}



void CCmdDlg::OnEnter() 
{
	m_cmd.Format(_T("%d"), EStdKeyDevice3 );
	SendCmd(ALIAS_KEY_SIMULATE);	
}

void CCmdDlg::OnLeft() 
{
	m_cmd.Format(_T("%d"), EStdKeyLeftArrow );
	SendCmd(ALIAS_KEY_SIMULATE);	
}

void CCmdDlg::OnRight() 
{
	m_cmd.Format(_T("%d"), EStdKeyRightArrow );
	SendCmd(ALIAS_KEY_SIMULATE);	
}


void CCmdDlg::OnApp()
{
	m_cmd.Format(_T("%d"), EStdKeyApplication0 );
	SendCmd(ALIAS_KEY_SIMULATE);
}


void CCmdDlg::OnBtn1()
{
	m_cmd.Format(_T("%d"), 49 );
	SendCmd(ALIAS_KEY_SIMULATE);
}


void CCmdDlg::OnBtn2()
{
	m_cmd.Format(_T("%d"), 50 );
	SendCmd(ALIAS_KEY_SIMULATE);
}

void CCmdDlg::OnBtn3()
{
	m_cmd.Format(_T("%d"), 51 );
	SendCmd(ALIAS_KEY_SIMULATE);
}

void CCmdDlg::OnBtn4()
{
	m_cmd.Format(_T("%d"), 52 );
	SendCmd(ALIAS_KEY_SIMULATE);
}

void CCmdDlg::OnBtn5()
{
	m_cmd.Format(_T("%d"), 53 );
	SendCmd(ALIAS_KEY_SIMULATE);
}

void CCmdDlg::OnBtn6()
{
	m_cmd.Format(_T("%d"), 54 );
	SendCmd(ALIAS_KEY_SIMULATE);
}

void CCmdDlg::OnBtn7()
{
	m_cmd.Format(_T("%d"), 55 );
	SendCmd(ALIAS_KEY_SIMULATE);
}

void CCmdDlg::OnBtn8()
{
	m_cmd.Format(_T("%d"), 56 );
	SendCmd(ALIAS_KEY_SIMULATE);
}

void CCmdDlg::OnBtn9()
{
	m_cmd.Format(_T("%d"), 57 );
	SendCmd(ALIAS_KEY_SIMULATE);
}


void CCmdDlg::OnBtn0()
{
	m_cmd.Format(_T("%d"), 48 );
	SendCmd(ALIAS_KEY_SIMULATE);
}

void CCmdDlg::OnBtnELeft()
{
	m_cmd.Format(_T("%d"), 42 );
	SendCmd(ALIAS_KEY_SIMULATE);
}

void CCmdDlg::OnBtnERight()
{
	m_cmd.Format(_T("%d"), 127 );
	SendCmd(ALIAS_KEY_SIMULATE);
}

void CCmdDlg::OnBtnC()
{
	m_cmd.Format(_T("%d"), 1 );
	SendCmd(ALIAS_KEY_SIMULATE);
}

void CCmdDlg::OnBtnPen()
{
	m_cmd.Format(_T("%d"), 18 );
	SendCmd(ALIAS_KEY_SIMULATE);
}

void CCmdDlg::OnBtnRed()
{
	m_cmd.Format(_T("%d"), EStdKeyNo );
	SendCmd(ALIAS_KEY_SIMULATE);
}

void CCmdDlg::OnBtnGreen()
{
	m_cmd.Format(_T("%d"), EStdKeyYes );
	SendCmd(ALIAS_KEY_SIMULATE);
}






//////////////////////////////////////////////////////////



CEvent g_Exit ;
CWinThread *pThread;



UINT fncThreadFunc(LPVOID lpv)
{
//================================================================//
	DWORD ms_cur ,ms_end;
	ms_end = 0;
	
	while(1)
	{
		ms_cur = GetTickCount();
		//--------------------------------
		if(WaitForSingleObject(g_Exit,0)==
			WAIT_OBJECT_0){
			return 1;
		}
		//--------------------------------
		if(ms_end<=ms_cur)
		{
			ms_end = GetTickCount() + 200;                        
			((CCmdDlg*)lpv)->StartSendReciver();
		}
		
	}
}
//================================================================//


void CCmdDlg::OnStartThread()
{

	if(!pThread)
	{
		pThread = AfxBeginThread(fncThreadFunc, this,		
			THREAD_PRIORITY_NORMAL
			/*THREAD_PRIORITY_BELOW_NORMAL*/
			/*THREAD_PRIORITY_ABOVE_NORMAL*/ 
			/*THREAD_PRIORITY_HIGHEST*/);
			pThread->m_bAutoDelete = FALSE;
		m_bThreadStarted = TRUE ;

	}
	else
	{
		DWORD exitcode;
		if(pThread)
		{
			g_Exit.SetEvent();
			do GetExitCodeThread(pThread->m_hThread,
				&exitcode);
			while(exitcode == STILL_ACTIVE);
			delete(pThread);
			pThread=NULL;
			m_bThreadStarted = FALSE;
			AfxMessageBox(_T("Thread is stoped!"));
		}
	}

}

CString strTime()
{
	CTime t = CTime::GetCurrentTime();
	CString strTime = t.Format( _T("%H:%M:%S ") );
	return strTime;
}

/////////////////////////////////////////////////////////////
//
//
//
//
void CCmdDlg::StartSendReciver()
{
	DWORD dwResult;

    TRACE(L"CCmdDlg::OnCapture(): Begin\n");
    {


		//   - 
		if( CMD_STATE_SENDDATA == m_iCmdState 
			&& (CONA_OK == m_iKeyEventState || ECONA_FILE_NOT_FOUND == m_iKeyEventState) )
		{			
			SendToPhone();
			m_iCmdState = CMD_STATE_NULL;
		}
		
		m_iKeyEventState = GetEventKeyState();
		if( CONA_OK == m_iKeyEventState )
		{
			//m_LogList.InsertItem(0, _T("EventKey:Ok") );
		}
		else
		{	if( ECONA_FILE_NOT_FOUND != m_iKeyEventState )
				{
				
				m_LogList.InsertItem(0, strTime() + CString(_T("EventKey:"))
				+ CONAError2String(m_iKeyEventState) );
				}
		}


		m_iSessionState = GetSessionState();
		if( CONA_OK == m_iSessionState )
		{
			//m_LogList.InsertItem(0, _T("Session:Ok") );

		}
		else
		{	if( ECONA_FILE_NOT_FOUND != m_iSessionState )
				m_LogList.InsertItem(0, CString(_T("Session:"))
				+ CONAError2String(m_iSessionState) );
		}




		dwResult = GetPicture();
		
		
		if(dwResult != CONA_OK)
		{
			// ErrorMessageDlg(L"CCmdDlg::OnCapture(): CONACopyFile failed!", dwResult);                
		}
		else
		{
			// show updated folder listing
			//m_lbPhones.ShowPhoneFolder(strPhoneFolder);
			//OK! AfxMessageBox(L"Copy completed succesfully!");
		}
    }

    TRACE(L"CCmdDlg::OnCapture(): End\n");
	
}



//
//
//
DWORD CCmdDlg::GetPicture()
{
	DWORD dwResult;
	//////////////////////////////////////////////////
	CString strPhoneFolderCapture = (_T("\\\\c:"));
	CString strPhoneFileCapture = (_T("capture.jpg"));
	//CString strPCFileCapture = (_T("c:\\capture.jpg"));			
	
	CONAPI_FILE_INFO FileInfo;
    unsigned char* pFileDataDevice = NULL;
    FileInfo.pstrName = strPhoneFileCapture.GetBuffer(_MAX_FNAME);
    FileInfo.dwAttributes = CONA_FPERM_READ | CONA_FPERM_DELETE;
    FileInfo.dwFileSize = 0;
    FileInfo.tFileTime.dwHighDateTime = NULL;
    FileInfo.tFileTime.dwLowDateTime = NULL;
    FileInfo.pstrMIMEType = NULL;
	
	dwResult = CONASetCurrentFolder(m_hFS, strPhoneFolderCapture);
    if( dwResult != CONA_OK )
 	{
		ErrorMessageDlg(L"CCmdDlg::GetPicture(): CONASetCurrentFolder failed!", dwResult);                
		return dwResult;
	}

	
	dwResult = CONAReadFile( m_hFS, &FileInfo, &pFileDataDevice, 0, NULL);
    if( dwResult != CONA_OK )
	{
		//ErrorMesssageDlg(L"CCmdDlg::GetPicture(): CONAReadFile failed!", dwResult);
		//ECONA_FILE_NOT_FOUND
		return dwResult;
	}
	
	
	
	if( m_ScreenPicture.LoadPictureData( pFileDataDevice, FileInfo.dwFileSize ) )
	{
		InvalidateRect(m_ScreenPictureRect);
	}


	// Free allocated resources
	CONAFreeFileDataMemory(pFileDataDevice); 



	dwResult = CONADeleteFile(m_hFS,           
		strPhoneFileCapture, 
		strPhoneFolderCapture);
	
	return dwResult;
}



//
//
//
void CCmdDlg::SendToPhone()
{
	DWORD dwResult;
	CString strPCFile (_T("cmd.txt")); // file name without path
	CString strPCFolder(_T("c:\\")); // e.g. 'c:\temp'
	CString strPhoneFolder = (_T("\\\\c:")); 

	dwResult = CONACopyFile(m_hFS, 
		CONA_DIRECT_PC_TO_PHONE | CONA_OVERWRITE, 
		strPCFile, 
		strPCFolder,  
		strPhoneFolder);
	
	if(dwResult != CONA_OK)
	{
		ErrorMessageDlg(L"CCmdDlg::SendCmd(): CONACopyFile failed!", dwResult);                
	}
	else
	{
		//OK! AfxMessageBox(L"Copy completed succesfully!");
	}
}



//
//
//
DWORD CCmdDlg::GetEventKeyState()
{
	
	DWORD dwResult;
	//////////////////////////////////////////////////
	CString strPhoneFolderEventKeyState = (_T("\\\\c:"));
	CString strPhoneFileEventKeyState = (_T("eventkey.txt"));
	//CString strPCFileEventKeyState = (_T("c:\\eventkey.txt"));			
	
	
	CONAPI_FILE_INFO FileInfo;
    unsigned char* pFileDataDevice = NULL;
    FileInfo.pstrName = strPhoneFileEventKeyState.GetBuffer(_MAX_FNAME);
    FileInfo.dwAttributes = CONA_FPERM_READ | CONA_FPERM_DELETE;
    FileInfo.dwFileSize = 0;
    FileInfo.tFileTime.dwHighDateTime = NULL;
    FileInfo.tFileTime.dwLowDateTime = NULL;
    FileInfo.pstrMIMEType = NULL;
	
	dwResult = CONASetCurrentFolder(m_hFS, strPhoneFolderEventKeyState);
    if( dwResult != CONA_OK )
 	{
		ErrorMessageDlg(L"CCmdDlg::GetEventKeyState(): CONASetCurrentFolder failed!", dwResult);                
		return dwResult;
	}

	
	dwResult = CONAReadFile( m_hFS, &FileInfo, &pFileDataDevice, 0, NULL);
    if( dwResult != CONA_OK )
	{
		//ErrorMesssageDlg(L"CCmdDlg::GetEventKeyState(): CONAReadFile failed!", dwResult);
		//ECONA_FILE_NOT_FOUND
		return dwResult;
	}
	
	
	CString strData(pFileDataDevice);
	strData.ReleaseBuffer(FileInfo.dwFileSize);
	m_LogList.InsertItem(0, CString( strTime() + _T("EventKey:") ) + strData );

	
	// Free allocated resources
	CONAFreeFileDataMemory(pFileDataDevice); 
	
	
	dwResult = CONADeleteFile(m_hFS,           
		strPhoneFileEventKeyState, 
		strPhoneFolderEventKeyState);
	
	return dwResult;
}


//
//
//
DWORD CCmdDlg::GetSessionState()
{
	
	DWORD dwResult;
	//////////////////////////////////////////////////
	CString strPhoneFolderSessionState = (_T("\\\\c:"));
	CString strPhoneFileSessionState = (_T("session.txt"));
	
	
	CONAPI_FILE_INFO FileInfo;
    unsigned char* pFileDataDevice = NULL;
    FileInfo.pstrName = strPhoneFileSessionState.GetBuffer(_MAX_FNAME);
    FileInfo.dwAttributes = CONA_FPERM_READ | CONA_FPERM_DELETE;
    FileInfo.dwFileSize = 0;
    FileInfo.tFileTime.dwHighDateTime = NULL;
    FileInfo.tFileTime.dwLowDateTime = NULL;
    FileInfo.pstrMIMEType = NULL;
	
	dwResult = CONASetCurrentFolder(m_hFS, strPhoneFolderSessionState);
    if( dwResult != CONA_OK )
 	{
		ErrorMessageDlg(L"CCmdDlg::GetSessionState(): CONASetCurrentFolder failed!", dwResult);                
		return dwResult;
	}

	
	dwResult = CONAReadFile( m_hFS, &FileInfo, &pFileDataDevice, 0, NULL);
    if( dwResult != CONA_OK )
	{
		//ErrorMesssageDlg(L"CCmdDlg::GetSessionState(): CONAReadFile failed!", dwResult);
		//ECONA_FILE_NOT_FOUND
		return dwResult;
	}
	
	
	CString strData(pFileDataDevice);
	strData.ReleaseBuffer(FileInfo.dwFileSize);
	m_LogList.InsertItem(0, strTime() + CString( _T("SessionState:") ) + strData );
	
	// Free allocated resources
	CONAFreeFileDataMemory(pFileDataDevice); 
	
	
	dwResult = CONADeleteFile(m_hFS,           
		strPhoneFileSessionState, 
		strPhoneFolderSessionState);
	
	return dwResult;
}


//
//
//
void CCmdDlg::OnDestroy() 
{

	DWORD exitcode;
	if(pThread)
	{
		//  
		g_Exit.SetEvent();
		do GetExitCodeThread(pThread->m_hThread,
			&exitcode);
		while(exitcode == STILL_ACTIVE);
		delete(pThread);
		pThread=NULL;
		
	}


	DWORD dwResult = CONACloseFS(m_hFS);
	if(dwResult != CONA_OK)
	{
		ErrorMessageDlg(L"~CCmdDlg::OnDestroy: CONACloseFS failed!", dwResult);                
	}
	else
	{
		// AfxMessageBox(_T("Ok CONACloseFS"));
	}

	CDialog::OnDestroy();
	
}

void CCmdDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	


	m_ScreenPicture.Show( &dc, m_ScreenPictureRect );


	
	// Do not call CDialog::OnPaint() for painting messages
}
