/*
==============================================================================
* PC Suite Connectivity API 1.1
*
Filename    : CONATypeDefinitions.h
Description : API Type Definitions
Version     : 1.1

Copyright (c) 2005 Nokia Corporation.
This software, including but not limited to documentation and any related 
computer programs ("Software"), is protected by intellectual property rights 
of Nokia Corporation and/or its licensors. All rights are reserved. By using 
the Software you agree to the terms and conditions hereunder. If you do not 
agree you must cease using the software immediately.
Reproducing, disclosing, modifying, translating, or distributing any or all 
of the Software requires the prior written consent of Nokia Corporation. 
Nokia Corporation retains the right to make changes to the Software at any 
time without notice.

A copyright license is hereby granted to use of the Software to make, publish, 
distribute, sub-license and/or sell new Software utilizing this Software. 
The Software may not constitute the primary value of any new software utilizing 
this software. No other license to any other intellectual property rights of 
Nokia or a third party is granted. 

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS 
OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF NON-INFRINGEMENT, 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL
NOKIA CORPORATION BE LIABLE FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL, 
OR CONSEQUENTIAL LOSS OR DAMAGES, INCLUDING BUT NOT LIMITED TO, LOST PROFITS 
OR REVENUE, LOSS OF USE, COST OF SUBSTITUTE PROGRAM, OR LOSS OF DATA OR EQUIPMENT 
ARISING OUT OF THE USE OR INABILITY TO USE THE MATERIAL, EVEN IF 
NOKIA CORPORATION HAS BEEN ADVISED OF THE LIKELIHOOD OF SUCH DAMAGES OCCURRING.
==============================================================================
*/
#ifndef _CONATYPEDEFINITIONS_H__
#define _CONATYPEDEFINITIONS_H__


// Type definition for DWORD
#ifndef DWORD
	typedef unsigned long       DWORD;
#endif

// Type definition for LPVOID
#ifndef LPVOID
	typedef void	           *LPVOID;
#endif

// Type definition for WCHAR
#ifndef WCHAR
	typedef unsigned short		WCHAR;
#endif

// Type definition for _FILETIME
//#ifndef _FILETIME_
#if !defined(_WINBASE_) && !defined(_FILETIME_)
	#pragma message ("\tConnAPI.h header included before Windows headers!") 
	#pragma message ("\tNote: If Windows headers will be used those MUST BE included before ConnAPI.h!")
	typedef struct _FILETIME {
		DWORD dwLowDateTime;
		DWORD dwHighDateTime;
	} FILETIME, *PFILETIME, *LPFILETIME;
	#define _FILETIME_
#endif

// Type definition for CALLBACK
#ifndef CALLBACK
	#define CALLBACK			__stdcall
#endif

#ifndef EXTERN_C
	#ifdef __cplusplus
		#define EXTERN_C    extern "C"
	#else
		#define EXTERN_C    extern
	#endif
#endif

#ifndef STDAPICALLTYPE
	#define STDAPICALLTYPE          __stdcall
#endif

#endif
