/*
Filename    : PhoneNavigator.cpp
Part of     : Phone Navigator
Description : Implementation of phone navigators application class
Version     : 1.1

This example is only to be used with PC Suite Connectivity API version 1.1.
Compability ("as is") with future versions is not quaranteed.

Copyright (c) 2005 Nokia Corporation.
 
This material, including but not limited to documentation and any related 
computer programs, is protected by intellectual property rights of Nokia 
Corporation and/or its licensors.
All rights are reserved. Reproducing, modifying, translating, or 
distributing any or all of this material requires the prior written consent 
of Nokia Corporation. Nokia Corporation retains the right to make changes 
to this material at any time without notice. A copyright license is hereby 
granted to download and print a copy of this material for personal use only.
No other license to any other intellectual property rights is granted. The 
material is provided "as is" without warranty of any kind, either express or 
implied, including without limitation, any warranty of non-infringement, 
merchantability and fitness for a particular purpose. In no event shall 
Nokia Corporation be liable for any direct, indirect, special, incidental, 
or consequential loss or damages, including but not limited to, lost profits 
or revenue,loss of use, cost of substitute program, or loss of data or 
equipment arising out of the use or inability to use the material, even if 
Nokia Corporation has been advised of the likelihood of such damages occurring.
*/ 

#include "stdafx.h"
#include "PhoneNavigator.h"
#include "PhoneNavigatorDlg.h"

#include "CmdDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//===================================================================
// CPhoneNavigatorApp

BEGIN_MESSAGE_MAP(CPhoneNavigatorApp, CWinApp)
	//{{AFX_MSG_MAP(CPhoneNavigatorApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

//===================================================================
// CPhoneNavigatorApp construction

CPhoneNavigatorApp::CPhoneNavigatorApp()
{
}

//===================================================================
// The one and only CPhoneNavigatorApp object

CPhoneNavigatorApp theApp;

//===================================================================
// CPhoneNavigatorApp initialization

BOOL CPhoneNavigatorApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif
        
	// Initialize Nokia PC Suite Connectivity API
	DWORD dwResult = CONAInitialize(CONA_API_VERSION, L"Nokia", NULL);
    if(dwResult == CONA_OK)
    { // CONAInitialize succeeded
        TRACE(L"CPhoneNavigatorApp::InitInstance(): CONAInitialize succeeded\n");
        {
            // The purpose of this code block is to
            // ensure that destructor of CPhoneNavigatorDlg
            // is called before CONAUninitialize call

	        //CPhoneNavigatorDlg dlg;
			CCmdDlg dlg;
	        m_pMainWnd = &dlg;

            // Show dialog
	        dlg.DoModal();
        }
        // Uninitialize Nokia PC Suite Connectivity API
	    dwResult = CONAUninitialize(0);
        if(dwResult != CONA_OK)
        { // CONAUninitialize failed
            TRACE(L"CPhoneNavigatorApp::InitInstance(): CONAUninitialize failed\n");
            ErrorMessageDlg(L"CPhoneNavigatorApp::InitInstance(): CONAUninitialize failed!", dwResult);
        }
        else
        {
            TRACE(L"CPhoneNavigatorApp::InitInstance(): CONAUninitialize succeeded\n");
        }
    }
    else
    { // CONAInitialize failed
        TRACE(L"CPhoneNavigatorApp::InitInstance(): CONAInitialize failed\n");
        ErrorMessageDlg(L"CPhoneNavigatorApp::InitInstance(): CONAInitialize failed!", dwResult);
    }

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
