/*
Filename    : PhoneNavigatorDlg.h
Part of     : Phone Navigator
Description : Declaration of phone navigators dialog class
Version     : 1.1

This example is only to be used with PC Suite Connectivity API version 1.1.
Compability ("as is") with future versions is not quaranteed.

Copyright (c) 2005 Nokia Corporation.
 
This material, including but not limited to documentation and any related 
computer programs, is protected by intellectual property rights of Nokia 
Corporation and/or its licensors.
All rights are reserved. Reproducing, modifying, translating, or 
distributing any or all of this material requires the prior written consent 
of Nokia Corporation. Nokia Corporation retains the right to make changes 
to this material at any time without notice. A copyright license is hereby 
granted to download and print a copy of this material for personal use only.
No other license to any other intellectual property rights is granted. The 
material is provided "as is" without warranty of any kind, either express or 
implied, including without limitation, any warranty of non-infringement, 
merchantability and fitness for a particular purpose. In no event shall 
Nokia Corporation be liable for any direct, indirect, special, incidental, 
or consequential loss or damages, including but not limited to, lost profits 
or revenue,loss of use, cost of substitute program, or loss of data or 
equipment arising out of the use or inability to use the material, even if 
Nokia Corporation has been advised of the likelihood of such damages occurring.
*/ 

#ifndef __NOKIA_PCCAPI_PHONE_NAVIGATOR_EXAMPLE__PHONENAVIGATORDLG__
#define __NOKIA_PCCAPI_PHONE_NAVIGATOR_EXAMPLE__PHONENAVIGATORDLG__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "PhoneListBox.h"
#include "FileListBox.h"

//===================================================================
// CPhoneNavigatorDlg dialog

class CPhoneNavigatorDlg : public CDialog
{
// Construction
public:
	CPhoneNavigatorDlg(CWnd* pParent = NULL);	// standard constructor
    virtual ~CPhoneNavigatorDlg();

// Dialog Data
	//{{AFX_DATA(CPhoneNavigatorDlg)
	enum { IDD = IDD_PHONENAVIGATOR_DIALOG };
	CStatic	m_staticPhone;
	CStatic	m_staticPCFiles;
	CPhoneListBox	m_lbPhones;
	CFileListBox	m_lbPCFiles;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPhoneNavigatorDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CPhoneNavigatorDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnEditchangeCboDrive();	
	afx_msg void OnButtonCopypc2phone();
	afx_msg void OnButtonMovephone2pc();
	afx_msg void OnButtonCopyphone2pc();
	afx_msg void OnButtonCreate();
	afx_msg void OnButtonRename();
	afx_msg void OnButtonDelete();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnButtonMovepc2phone();
	afx_msg void OnButtonBtPairing();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
    void RefreshPhoneList();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(__NOKIA_PCCAPI_PHONE_NAVIGATOR_EXAMPLE__PHONENAVIGATORDLG__)
